pipeline {
    agent any
     tools {
       // maven 'apache-maven-3.6.3'
        maven 'maven'
        jdk 'JDK_HOME'
    }
    stages {
    
        stage('Build') {
            steps {
               echo "This is Build"
               
              /* sh '''
                cd happytrip-code
                java -version
                mvn clean install
                '''*/
                bat '''
                cd happytrip-code
                java -version
                mvn clean install
                '''
            }
        }
        
        stage('SonarQube') {
            steps{
                // SonarQube taskId is automatically attached to the pipeline context
                bat '''
                    cd happytrip-code
                    mvn sonar:sonar \
                    -Dsonar.projectKey=HappyTrip \
                    -Dsonar.host.url=http://localhost:9000 \
                    -Dsonar.login=303abb756d68c3235eb1692016bac744b25918bd
                '''
            } 
        }
        
        stage('Test') {
            steps {
                bat '''
                 cd happytrip-code
                 mvn -B verify
                 '''
            }
        }
        
        stage('Deploy') {
			steps {
				echo "Deploying"
				deploy adapters: [tomcat7(credentialsId: 'e693e239-5951-493a-a3b2-d78524a6a2c0', path: '', url: 'http://localhost:9080')], contextPath: 'HappyTrip', war: '**/*.war'
		    }
	    }

    }
    
    post {
        always {
            //archiveArtifacts artifacts: 'generatedFile.log', onlyIfSuccessful: true
          
            emailext attachLog: true,
                body: "${currentBuild.currentResult}: Job ${env.JOB_NAME} build ${env.BUILD_NUMBER}\n More info at: ${env.BUILD_URL}",
                recipientProviders: [developers(), requestor()],
                subject: "Jenkins Build :- ${currentBuild.currentResult}: Job ${env.JOB_NAME}"
            
        }
    }
}